"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const console_definition_1 = require("../console-definition");
const bridge_1 = require("../../../bridge");
describe('ConsoleDefinition', () => {
    let bridge;
    beforeEach(() => {
        bridge = {
            call: jest.fn(),
            callIgnored: jest.fn(),
            callSync: jest.fn()
        };
    });
    describe('setup', () => {
        it('populates console methods and delegates calls to the bridge', () => {
            const def = new console_definition_1.ConsoleDefinition();
            const glob = {};
            def.define(bridge, glob);
            glob.console.log('test');
            expect(bridge.call).toHaveBeenCalledWith('logConsole', 'log', expect.any(bridge_1.BridgeSerializer));
        });
    });
});
