"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const process_definition_1 = require("../process-definition");
describe('ProcessDefinition', () => {
    let bridge;
    beforeEach(() => {
        bridge = {
            call: jest.fn(),
            callIgnored: jest.fn(),
            callSync: jest.fn()
        };
    });
    describe('setup', () => {
        it('populates process methods', () => {
            const def = new process_definition_1.ProcessDefinition();
            const glob = {
                runtimeStaticConfig: {
                    process: {
                        platform: 'forge',
                        version: 'version',
                        versions: {}
                    }
                }
            };
            def.define(bridge, glob);
            expect(glob.process.platform).toBe('forge');
            expect(glob.process.version).toBe('version');
            expect(glob.process.versions).toStrictEqual({});
        });
    });
});
