"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bridge_1 = require("../../bridge");
const util_1 = require("../../util");
const abstract_definition_1 = require("./abstract-definition");
class ConsoleDefinition extends abstract_definition_1.AbstractDefinition {
    constructor() {
        super(...arguments);
        this.logConsole = (method) => (...args) => {
            this.bridge.call('logConsole', method, new bridge_1.BridgeSerializer((externalCopy, _) => args.map((arg) => util_1.transformNonTransferablesForLogging(externalCopy, arg))));
        };
    }
    definePreBootstrap(global) {
        global.console = {
            debug: this.logConsole('debug'),
            error: this.logConsole('error'),
            warn: this.logConsole('warn'),
            info: this.logConsole('info'),
            log: this.logConsole('log')
        };
    }
    definePostBootstrap(global) { }
}
exports.ConsoleDefinition = ConsoleDefinition;
