"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const abstract_definition_1 = require("./abstract-definition");
class InvokeDefinition extends abstract_definition_1.AbstractDefinition {
    definePreBootstrap(global) { }
    definePostBootstrap(global) {
        Object.defineProperty(global, '__invoke', {
            configurable: false,
            enumerable: false,
            writable: false,
            value: (fn, args, context, resolve, reject) => {
                const scopedFn = global[fn] || exports[fn];
                if (!scopedFn) {
                    throw new Error(`Can't invoke a function "${fn}". Maybe it's not exported?`);
                }
                const result = scopedFn.apply(undefined, [args, context]);
                Promise.resolve(result)
                    .then((result) => {
                    void this.bridge.applyIgnored(resolve, result);
                })
                    .catch((err) => {
                    void this.bridge.applyIgnored(reject, err);
                });
            }
        });
    }
}
exports.InvokeDefinition = InvokeDefinition;
