"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const abstract_definition_1 = require("./abstract-definition");
class ProcessDefinition extends abstract_definition_1.AbstractDefinition {
    definePreBootstrap(global) {
        const config = global.runtimeStaticConfig;
        delete global.runtimeStaticConfig;
        global.process = {
            ...config?.process,
            nextTick: (callback, ...args) => global.setTimeout(callback, 0, ...args),
            stdin: ProcessDefinition.createIOStream(0),
            stdout: ProcessDefinition.createIOStream(1),
            stderr: ProcessDefinition.createIOStream(2)
        };
        function process() { }
        Object.defineProperty(process.prototype, Symbol.toStringTag, {
            get: () => 'process'
        });
        Object.setPrototypeOf(global.process, process.prototype);
    }
    definePostBootstrap(global) {
        global.process.env = JSON.parse(this.bridge.callSync('getUserVars'));
    }
}
exports.ProcessDefinition = ProcessDefinition;
ProcessDefinition.createIOStream = (fd) => ({ fd });
