"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const abstract_definition_1 = require("./abstract-definition");
const bridge_1 = require("../../bridge");
class TimerDefinition extends abstract_definition_1.AbstractDefinition {
    constructor() {
        super(...arguments);
        this.setTimeout = (callback, ms, ...args) => {
            return this.bridge.callSync('setTimeout', new bridge_1.BridgeSerializer((_, wrapFunction) => ({
                callback: wrapFunction(() => callback(...args)),
                ms
            })));
        };
        this.clearTimeout = (id) => {
            return this.bridge.callSync('clearTimeout', () => ({ id }));
        };
        this.setInterval = (callback, ms, ...args) => {
            return this.bridge.callSync('setInterval', new bridge_1.BridgeSerializer((_, wrapFunction) => ({
                callback: wrapFunction(() => callback(...args)),
                ms
            })));
        };
        this.clearInterval = (id) => {
            return this.bridge.callSync('clearInterval', () => ({ id }));
        };
    }
    definePreBootstrap(global) {
        global.setTimeout = this.setTimeout;
        global.clearTimeout = this.clearTimeout;
        global.setInterval = this.setInterval;
        global.clearInterval = this.clearInterval;
    }
    definePostBootstrap(global) { }
}
exports.TimerDefinition = TimerDefinition;
