"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const abstract_definition_1 = require("../abstract-definition");
class GetSnapshotLogsDefinition extends abstract_definition_1.AbstractDefinition {
    normalizeLogLevel(level) {
        switch (level) {
            case 'warn':
                return 'warning';
            case 'log':
                return 'info';
            default:
                return level;
        }
    }
    definePreBootstrap(global) {
        global.getSnapshotLogs = (ivm) => {
            delete global.getSnapshotLogs;
            const toExternalCopy = (value) => new ivm.ExternalCopy(value);
            const deferedLogs = this.bridge.getDeferedInvocations().map(({ args }) => ({
                level: this.normalizeLogLevel(args[0]),
                args: args[1].serialize(toExternalCopy)
            }));
            return new ivm.ExternalCopy(deferedLogs, { release: true, transferOut: true }).copyInto();
        };
    }
    definePostBootstrap(global) { }
}
exports.GetSnapshotLogsDefinition = GetSnapshotLogsDefinition;
